stages:
  - test
  - build-archive
  - build-docker
  - release

variables:
  CONTAINER_TEST_IMAGE: registry.gitlab.com/creator-makerspace/gatekeeper-ui:$CI_BUILD_REF_NAME
  CONTAINER_RELEASE_IMAGE: registry.gitlab.com/creator-makerspace/gatekeeper-ui:latest

test:
  image: node:7.0.0
  script:
    #- npm run test
    - echo 

build-archive:
  before_script:
    - npm install -g yarn
  cache:
    paths:
      - $HOME/.yarn-cache
  image: node:7.0.0
  stage: build-archive
  tags:
    - gk-runner
  script:
    - yarn
    - npm run build
    - tar -cvf gatekeeper-ui-$CI_BUILD_REF_NAME.tar dist
    - gzip gatekeeper-ui-$CI_BUILD_REF_NAME.tar
    - scp -o StrictHostKeyChecking=no -i /ci/id_rsa gatekeeper-ui-$CI_BUILD_REF_NAME.tar.gz ci@185.56.187.65:files

build-docker:
  before_script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
  image: docker:git
  stage: build-docker
  tags:
    - gk-runner
  script:
    - scp -o StrictHostKeyChecking=no -i /ci/id_rsa ci@185.56.187.65:files/gatekeeper-ui-$CI_BUILD_REF_NAME.tar.gz .
    - tar -xvf gatekeeper-ui-$CI_BUILD_REF_NAME.tar.gz
    - docker build -t $CONTAINER_TEST_IMAGE .
    - docker push $CONTAINER_TEST_IMAGE

release-image:
  before_script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
  image: docker:git
  stage: release
  tags:
  - gk-runner
  script:
    - docker pull $CONTAINER_TEST_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE
    - docker push $CONTAINER_RELEASE_IMAGE
  only:
    - master
    - tags
